【HDU6319】Ascending Rating(单调队列)

题目链接

Problem A. Ascending Rating

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
Total Submission(s): 4510    Accepted Submission(s): 1506


 

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i -th contestant's QodeForces rating is ai .
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m , say [l,l+m−1] , and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1 and count=0 . Everytime he meets a contestant k with strictly higher rating than maxrating , he will change maxrating to ak and count to count+1 .
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count . Please write a program to figure out the answer.

 

Input

The first line of the input contains an integer T(1≤T≤2000) , denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD .
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109) , denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD


It is guaranteed that ∑n≤7×107 and ∑k≤2×106 .  

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1] .
For each test case, you need to print a single line containing two integers A and B , where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)


Note that ``⊕ '' denotes binary XOR operation.  

Sample Input

 

1

10 6 10 5 5 5 5

3 2 2 1 5 7 6 8 2 9

 

Sample Output

 

46 11

 

Source

2018 Multi-University Training Contest 3

解题思路:

又是知识盲区qaq不过没关系不会就学嘛

这里用到单调队列,单调队列就是用来维护区间最大值的,这里需要把序列倒过来维护递减序列。这样队列中元素个数就是count个数(倒的是递减正的就是递增所以每两个相邻都会让count加一,加上最开始0正好是队列个数),队头就是最大值。

还有就是这里计算a[i]的时候int可能会炸,需要用long long 

代码:

#include<bits/stdc++.h>
typedef long long LL;
using namespace std;
LL a[10000005],Q[10000005];
int main()
{
	int T;
	scanf("%d",&T);
	while(T--){
		LL n,m,k,p,q,r,mod;
		scanf("%lld%lld%lld%lld%lld%lld%lld",&n,&m,&k,&p,&q,&r,&mod);
		for(LL i=1;i<=k;i++)scanf("%lld",&a[i]);
		for(LL i=k+1;i<=n;i++)a[i]=(p*a[i-1]+q*i+r)%mod;
		int rear=0,head=1;
		LL ans1=0,ans2=0;
		for(LL i=n;i>0;i--){
			while(rear>=head && a[Q[rear]]<=a[i])rear--;
			Q[++rear]=i;
			if(i+m-1<=n){
				while(Q[head]>=i+m)head++;
				ans1+=a[Q[head]]^i;
				ans2+=(rear-head+1)^i;
			}
		}
		printf("%lld %lld\n",ans1,ans2);
	}
	return 0;
	
}

猜你喜欢

转载自blog.csdn.net/qq_39826163/article/details/81458552